'use strict';

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

exports.__esModule = true;

var _tagOrFunc = require('../utils/tag-or-func');

var _tagOrFunc2 = _interopRequireDefault(_tagOrFunc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Globals = function () {
    function Globals(filename) {
        (0, _classCallCheck3.default)(this, Globals);

        this.filename = filename;
        this.currentFixture = null;
        this.collectedTests = [];

        this.globalFunctions = {
            'fixture': (0, _tagOrFunc2.default)(this._onFixture.bind(this)),
            'page': (0, _tagOrFunc2.default)(this._onPage.bind(this)),
            'test': this._onTest.bind(this)
        };
    }

    Globals.prototype._onFixture = function _onFixture(name) {
        this.currentFixture = {
            name: name,
            path: this.filename,
            page: 'about:blank'
        };
    };

    Globals.prototype._onPage = function _onPage(url) {
        this.currentFixture.page = url;
    };

    Globals.prototype._onTest = function _onTest(name, fn) {
        this.collectedTests.push({
            name: name,
            fixture: this.currentFixture,
            fn: fn
        });
    };

    Globals.prototype.setup = function setup() {
        var _this = this;

        (0, _keys2.default)(this.globalFunctions).forEach(function (name) {
            return global[name] = _this.globalFunctions[name];
        });
    };

    Globals.prototype.remove = function remove() {
        (0, _keys2.default)(this.globalFunctions).forEach(function (name) {
            return delete global[name];
        });
    };

    return Globals;
}();

exports.default = Globals;
module.exports = exports['default'];