'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.__esModule = true;

var _qrcodeTerminal = require('qrcode-terminal');

var _qrcodeTerminal2 = _interopRequireDefault(_qrcodeTerminal);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _log = require('./log');

var _log2 = _interopRequireDefault(_log);

var _promisifyEvent = require('promisify-event');

var _promisifyEvent2 = _interopRequireDefault(_promisifyEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(testCafe, remoteCount, showQRCode) {
        var connections, i, browserConnection;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        connections = [];

                        if (!remoteCount) {
                            _context.next = 16;
                            break;
                        }

                        _log2.default.hideSpinner();

                        i = 0;

                    case 4:
                        if (!(i < remoteCount)) {
                            _context.next = 15;
                            break;
                        }

                        browserConnection = testCafe.createBrowserConnection();

                        _log2.default.write('To connect a remote browser #' + (i + 1) + ', use it to open ' + _chalk2.default.underline.blue(browserConnection.url));

                        if (showQRCode) {
                            _log2.default.write('or scan this QR-code:\n');
                            _qrcodeTerminal2.default.generate(browserConnection.url);
                        }

                        _context.next = 10;
                        return (0, _promisifyEvent2.default)(browserConnection, 'ready');

                    case 10:

                        connections.push(browserConnection);
                        _log2.default.write(_chalk2.default.green('CONNECTED') + ' ' + browserConnection.userAgent + '\n');

                    case 12:
                        i++;
                        _context.next = 4;
                        break;

                    case 15:

                        _log2.default.showSpinner();

                    case 16:
                        return _context.abrupt('return', connections);

                    case 17:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));
    return function (_x, _x2, _x3) {
        return ref.apply(this, arguments);
    };
}();

module.exports = exports['default'];