'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

exports.__esModule = true;

var _fs = require('fs');

var fs = _interopRequireWildcard(_fs);

var _flatten = require('flatten');

var _flatten2 = _interopRequireDefault(_flatten);

var _stripBom = require('strip-bom');

var _stripBom2 = _interopRequireDefault(_stripBom);

var _arrayFind = require('array-find');

var _arrayFind2 = _interopRequireDefault(_arrayFind);

var _testcafeLegacyApi = require('testcafe-legacy-api');

var _testcafeHammerhead = require('testcafe-hammerhead');

var _esNext = require('./es-next');

var _esNext2 = _interopRequireDefault(_esNext);

var _promisify = require('../utils/promisify');

var _promisify2 = _interopRequireDefault(_promisify);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var readFile = (0, _promisify2.default)(fs.readFile);

var Compiler = function () {
    function Compiler(sources) {
        (0, _classCallCheck3.default)(this, Compiler);

        this.sources = sources;
        this.esNextCompiler = new _esNext2.default();

        this.compilers = [new _testcafeLegacyApi.Compiler(_testcafeHammerhead.wrapDomAccessors), this.esNextCompiler];
    }

    Compiler.prototype._compileFile = function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(filename) {
            var code, compiler;
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            _context.next = 2;
                            return readFile(filename);

                        case 2:
                            code = _context.sent;

                            code = (0, _stripBom2.default)(code).toString();

                            compiler = (0, _arrayFind2.default)(this.compilers, function (c) {
                                return c.canCompile(code, filename);
                            });
                            return _context.abrupt('return', compiler ? compiler.compile(code, filename) : null);

                        case 6:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, this);
        }));
        return function _compileFile(_x) {
            return ref.apply(this, arguments);
        };
    }();

    Compiler.prototype.getTests = function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
            var _this = this;

            var compileUnits, tests;
            return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            compileUnits = this.sources.map(function (filename) {
                                return _this._compileFile(filename);
                            });
                            _context2.next = 3;
                            return _promise2.default.all(compileUnits);

                        case 3:
                            tests = _context2.sent;

                            this.esNextCompiler.cleanUpCache();

                            return _context2.abrupt('return', (0, _flatten2.default)(tests).filter(function (test) {
                                return !!test;
                            }));

                        case 6:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, _callee2, this);
        }));
        return function getTests() {
            return ref.apply(this, arguments);
        };
    }();

    return Compiler;
}();

exports.default = Compiler;
module.exports = exports['default'];